Redmine - Patch #3274

Wiki Page Categories
2009-04-30 13:21 - Sven Schwyn

Status: New Start date: 2009-04-30
Priority: Normal Due date:

Assignee: % Done: 0%
Category: Wiki Estimated time: 0.00 hour
Target version:

Description

This patch is a preliminary implementation of wiki page categories (think: Wikipedia) for Redmine.

The patch is against Redmine 0.8.3. Watch it in action here:
http://www.bitcetera.com/assets/media/wiki_page_categories.mov

Please note that | haven't written nor adapted any tests/fixtures yet. If you choose to adopt this patch, I'll catch up on this.

History

#1 - 2009-05-15 09:18 - Sven Schwyn

I've just seen that patches are supposed to be against the trunk. No problem, | can do that, but I'd love to hear beforehand if the patch stands a
chance to be merged at all. Thanks!

#2 - 2009-05-15 19:46 - Eric Davis

| love the feature idea but we will need to have the patch apply to trunk and also to have some tests (especially for ApplicationHelper). Would you
mind updating the patch?

Also the screencast was great. It really made it easy to see what functionality was included.

#3 - 2009-05-18 14:10 - Sven Schwyn
- % Done changed from 80 to 100

I've applied the patch (with routes adapted) against the mirror on Github and added "Index by category" and "Pages without category" to the
featureset. Furthermore, I've written a bunch of tests as well.

http://github.com/svoop/redmine/tree/master

Shall | create a patch against the current master or do a pull request on Github?

#4 - 2009-05-20 09:11 - Sven Schwyn
- File wiki_page_categories_20090520.patch added

Here are the changes against upstream master as of today.

#5 - 2009-06-29 20:51 - Eric Davis
- Assignee set to Eric Davis

- % Done changed from 100 to 0

Sven has asked me to take a look at this patch. Assigning to myself as a reminder.

#6 - 2009-10-04 12:18 - Sven Schwyn

I'm trying to clean up my contributions to a few projects before | loose the overview. This patch is several months now, do you see a chance to apply it
any time soon? Or is there anything | can do to make this more likely to happen such as rebasing on Github or creating a new patch against the
current trunk?

#7 - 2009-10-24 01:50 - Sven Schwyn

I've forked anew on Github and added the wiki page categories feature again. (Rebasing caused a funky issue | couldn't resolve.)

Please DON'T use the above patch, it has a bug which is fixed in this new commit on Github:
http://www.bitcetera.com/assets/media/wiki_page_categories.mov
http://github.com/svoop/redmine/commit/e06a07e0f004e2{826687e1d10611a5162eef4f2

#8 - 2009-11-08 02:39 - Eric Davis
- File wiki-categories-3274.patch added

- Status changed from New to 7

I did a quick review of the patch (included) and the feature looks good. A concern | have is storing the categories as a delimited string on a wiki page.
It makes querying for the categories harder (e.g. SQL LIKE) and requires the code to do a bunch of string processing to split and join them each time
they are used. What if we use a full database model to store the Wiki categories and associte them with the wiki pages themselves?

#9 - 2009-11-08 09:45 - Jean-Philippe Lang

- Status changed from 7 to New

-1.

| find very odd the way to assign a category to a page.

A proper Tag model should be used and extended to tickets, forums...
See #480, #2897

#10 - 2009-11-08 09:46 - Jean-Philippe Lang

Instead, we'd better review the existing Tagging plugins for Rails app to choose one.

#11 - 2009-11-08 12:12 - Sven Schwyn

Fair point, Jean-Philippe. I'm used to Mediawiki, so | took the approach from there which may or may not be a fit for Redmine. (However, | would have
preferred to get opinions before doing the extra work, after all, it was easy to see from the screencast. Don't particularly like to code into the
wastebin.)

Never mind, is there a particular tagging plugin you have in mind?

#12 - 2009-11-08 13:27 - Sven Schwyn

I've only used tagging once so far (with the acts-as-taggable-on plugin). From a Ul point of view, would it be better to edit the tags on the "edit wiki
page" view or directly in the sidebar?

By the way, | guess the reason why Mediawiki sets the page category (or tag) in the content itself is to include the page category (or tag) in the
history.

#13 - 2009-11-17 18:59 - Sven Schwyn

I'll do an alternative implementation based on tagging. The tags will be displayed in the show view sidebar and can be edited in the edit view. (A
future enhancement could be AJAX editing directly in the sidebar.)

| favour acts_as_taggable_on (as it's the only one | have used so far). Any other suggestions for the tagging plugin?

http://return42.blogspot.com/2009/07/many-ways-to-tag-taggables.html

#14 - 2010-10-25 17:02 - Eric Davis

- Assignee deleted (Eric Davis)

Files

wiki_page_categories.patch 8.69 KB 2009-04-30 Sven Schwyn
wiki_page_categories_20090520.patch 39.4 KB 2009-05-20 Sven Schwyn
wiki-categories-3274.patch 43.1 KB 2009-11-08 Eric Davis
